#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/select.h>

#include "inotify.h"

#define ALL_MASK 0xffffffff

#include "inotify.h"
#include "event_queue.h"

int main (int argc, char **argv)
{
	queue_t q;
	int fd;

	if (argc < 2) {
		printf("Usage: %s path\n", argv[0]);
		return -1;
	}

	fd = open_dev();

	if (fd < 0) {
		printf("Could not open inotify device\n");
		return -1;
	}

	q = queue_create (128);

	watch_dir (fd, argv[1], ALL_MASK);

	read_and_print_events (q, fd);

	queue_destroy (q);

	close_dev (fd);
	return 0;
}
